#include "jde.h"
#include "obijuan.h"

int finish_flag=0; 

int obijuan_id=0; 
int obijuan_brothers[MAX_SCHEMAS];
arbitration obijuan_callforarbitration;
int obijuan_cycle=150; /* ms */ 

void obijuan_iteration()
{
	printf("Obijuan: May the source be with you...\n");
}

void obijuan_suspend()
{
  pthread_mutex_lock(&(all[obijuan_id].mymutex));
  put_state(obijuan_id,slept);
  printf("obijuan: off\n");
  pthread_mutex_unlock(&(all[obijuan_id].mymutex));
} 


void obijuan_resume(int father, int *brothers, arbitration fn)
{
  int i;
 
  pthread_mutex_lock(&(all[obijuan_id].mymutex));
  /* this schema resumes its execution with no children at all */
  for(i=0;i<MAX_SCHEMAS;i++) all[obijuan_id].children[i]=FALSE;
 
  all[obijuan_id].father=father;
  if (brothers!=NULL) {
    for(i=0;i<MAX_SCHEMAS;i++) obijuan_brothers[i]=-1;
    i=0;
    while(brothers[i]!=-1) {obijuan_brothers[i]=brothers[i];i++;}
  }
  obijuan_callforarbitration=fn;
  put_state(obijuan_id,notready);
  printf("obijuan: on\n");
  pthread_cond_signal(&(all[obijuan_id].condition));
  pthread_mutex_unlock(&(all[obijuan_id].mymutex));
} 

void *obijuan_thread(void *not_used) 
{
  struct timeval a,b;
  long diff, next;

  for(;finish_flag==0;) {
    pthread_mutex_lock(&(all[obijuan_id].mymutex));

    if (all[obijuan_id].state==slept) {
	    pthread_cond_wait(&(all[obijuan_id].condition),&(all[obijuan_id].mymutex));
	    pthread_mutex_unlock(&(all[obijuan_id].mymutex));
	  }
    else {
	    /* check preconditions. For now, preconditions are always satisfied*/
	    if (all[obijuan_id].state==notready) put_state(obijuan_id,ready);
      
      /* check brothers and arbitrate. For now this is the only winner */
	    else if (all[obijuan_id].state==ready) { 
	      put_state(obijuan_id,winner);
	    }	  
	    else if (all[obijuan_id].state==winner);

	    if (all[obijuan_id].state==winner) {
	      /* I'm the winner and must execute my iteration */
	      pthread_mutex_unlock(&(all[obijuan_id].mymutex));
	      gettimeofday(&a,NULL);
	      obijuan_iteration();
	      gettimeofday(&b,NULL);  

	      diff = (b.tv_sec-a.tv_sec)*1000000+b.tv_usec-a.tv_usec;
	      next = obijuan_cycle*1000-diff-10000; 
	      if (next>0) 
		      /* discounts 10ms taken by calling usleep itself */
		      usleep(obijuan_cycle*1000-diff);
	      else { 
		      /* just let this iteration go away. overhead time negligible */
		      printf("time interval violated: obijuan\n"); 
		      usleep(obijuan_cycle*1000);
		    }
	    }
	    else {
	      pthread_mutex_unlock(&(all[obijuan_id].mymutex));
	      usleep(obijuan_cycle*1000);
	    }
	  }
  }
  
  return NULL;
} 

void obijuan_stop()
{
  finish_flag=1;
  printf ("obijuan close\n");
}

void obijuan_startup(char *configfile)
{
  printf ("Config file: %s\n",configfile);
  
  pthread_mutex_lock(&(all[obijuan_id].mymutex));
  myexport("obijuan","id",&obijuan_id);
  printf("obijuan schema started up\n");
  put_state(obijuan_id,slept);
  pthread_create(&(all[obijuan_id].mythread),NULL,obijuan_thread,NULL);
  pthread_mutex_unlock(&(all[obijuan_id].mymutex));
}

void obijuan_guiresume()
{
  printf ("gui_resume\n");
}

void obijuan_guisuspend()
{
 printf ("gui_suspend\n");
}

